#include <bits/stdc++.h>

using namespace std;


int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

int lcm(int a, int b) {
    return a / gcd(a, b) * b;
}

int bpm(int a, int n) // bin pow
 {
    if (n == 0) return 1;
    if (n % 2 == 1) return bpm(a, n - 1) * a;
    int tmp = bpm(a, n / 2);
    return tmp * tmp;
 }

vector < vector <int> > g;
vector <int> c;

void paint(int u, int k) {
    if (k == 0) return;
    c[u] = k;
    k--;
    for (int  i = 0; i < g[u].size(); i++) {
        paint(g[u][i], k);
    }
}


void solve() {
    int n, m, k, tmpA, tmpB;
    cin >> n >> m >> k;
    g.resize(n);
    c.resize(n, -1);
    for (int i = 0; i < m; i++) {
        cin >> tmpA >> tmpB;
        tmpA--;
        tmpB--;
        g[tmpA].push_back(tmpB);
        g[tmpB].push_back(tmpA);
    }
    for (int i = 0; i < k; i++) {
        cin >> tmpA >> tmpB;
        tmpA--;
        paint(tmpA, 1 + tmpB);
    }
    int ans;
    vector <int> ansv;
    for (int i = 0; i < n; i++) {
        if (c[i] != -1) {
           ans++;
           ansv.push_back(i);
        }
    }
    cout << ans << endl;
    for (int i = 0; i < ansv.size(); i++) cout << ansv[i] + 1 << " ";
}

signed main()
{
    solve();
}
